/// <reference types="klaw" />
import { HTTP } from 'http-call';
import { Help as CLICommandHelp } from 'cli-engine-command/lib/help';
import * as moment from 'moment';
import * as klaw from 'klaw';
import Heroku = require('cli-engine-heroku');
import semver = require('semver');
import Hooks = require('./hooks');
import help = require('./commands/help');
import notFound = require('./not_found');
import updater = require('./updater');
import util = require('./util');
import file = require('./file');
import lock = require('./lock');
import Builtin = require('./plugins/builtin');
import Plugins = require('./plugins');
import linkPlugins = require('./plugins/link');
import corePlugins = require('./plugins/core');
import userPlugins = require('./plugins/user');
import yarn = require('./plugins/yarn');
import pluginManifest = require('./plugins/manifest');
import pluginCache = require('./plugins/cache');
import pluginLegacy = require('./plugins/legacy');
import pluginsMigrate = require('./plugins/migrate');
declare const _default: {
    readonly CLICommandHelp: typeof CLICommandHelp;
    readonly HTTP: typeof HTTP;
    readonly moment: typeof moment;
    readonly rwlockfile: any;
    readonly klaw: (root: string, options?: klaw.Options | undefined) => klaw.Walker;
    readonly crossSpawn: any;
    readonly Heroku: typeof Heroku;
    readonly stripAnsi: (str: string) => string;
    readonly semver: typeof semver;
    readonly Help: typeof help.Help;
    readonly Hooks: typeof Hooks.Hooks;
    readonly Lock: typeof lock.Lock;
    readonly NotFound: typeof notFound.NotFound;
    readonly Updater: typeof updater.Updater;
    readonly util: typeof util;
    readonly file: typeof file;
    readonly Builtin: typeof Builtin.Builtin;
    readonly LinkPlugins: typeof linkPlugins.LinkPlugins;
    readonly Plugins: typeof Plugins.Plugins;
    readonly UserPlugins: typeof userPlugins.UserPlugins;
    readonly CorePlugins: typeof corePlugins.CorePlugins;
    readonly Yarn: typeof yarn.Yarn;
    readonly PluginManifest: typeof pluginManifest.PluginManifest;
    readonly PluginCache: typeof pluginCache.PluginCache;
    readonly PluginLegacy: typeof pluginLegacy.PluginLegacy;
    readonly PluginsMigrate: typeof pluginsMigrate.PluginsMigrate;
};
export default _default;
