import { PluginModule, PluginPJSON } from './plugins/plugin';
import { Config, ICommand } from 'cli-engine-config';
export declare type PreRunOptions = {
    Command: ICommand;
    argv: string[];
};
export declare type PluginsParseHookOptions = {
    module: PluginModule;
    pjson: PluginPJSON;
};
export declare class Hooks {
    config: Config;
    constructor(config: Config);
    run(event: 'init'): Promise<void>;
    run(event: 'update'): Promise<void>;
    run(event: 'prerun', options: PreRunOptions): Promise<void>;
    run(event: 'plugins:parse', options: PluginsParseHookOptions): Promise<void>;
}
