"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deps_1 = require("./deps");
const path = require("path");
const debug = require('debug')('cli:hooks');
class Hooks {
    constructor(config) {
        this.config = config;
    }
    async run(event, options = {}) {
        let scripts = this.config.hooks[event];
        if (!scripts)
            return;
        for (let script of scripts) {
            script = path.join(this.config.root, script);
            debug(`%s %s`, event, script);
            const m = deps_1.default.util.undefault(require(script));
            await m(this.config, options);
        }
    }
}
exports.Hooks = Hooks;
