"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deps_1 = require("./deps");
const heroku_cli_color_1 = require("heroku-cli-color");
const cli_ux_1 = require("cli-ux");
const cli_engine_command_1 = require("cli-engine-command");
class NotFound extends cli_engine_command_1.Command {
    async run() {
        this.plugins = new deps_1.default.Plugins({ config: this.config });
        await this.plugins.init();
        let closest;
        let binHelp = `${this.config.bin} help`;
        let id = this.config.argv[0];
        let idSplit = id.split(':');
        if (await this.plugins.findTopic(idSplit[0])) {
            // if valid topic, update binHelp with topic
            binHelp = `${binHelp} ${idSplit[0]}`;
            // if topic:COMMAND present, try closest for id
            if (idSplit[1])
                closest = this.closest(id);
        }
        else {
            closest = this.closest(id);
        }
        let perhaps = closest ? `Perhaps you meant ${heroku_cli_color_1.color.yellow(closest)}\n` : '';
        cli_ux_1.default.error(`${heroku_cli_color_1.color.yellow(id)} is not a ${this.config.bin} command.
${perhaps}Run ${heroku_cli_color_1.color.cmd(binHelp)} for a list of available commands.`, { exitCode: 127 });
    }
    allCommands() {
        let ids = this.plugins.commandIDs;
        return ids;
        // TODO add aliases
        // return this.commandManager.listCommandIDs().reduce((commands, c) => {
        //   return commands.concat([c.id]).concat(c.aliases || [])
        // }, [])
    }
    closest(cmd) {
        const DCE = require('string-similarity');
        return DCE.findBestMatch(cmd, this.allCommands()).bestMatch.target;
    }
}
NotFound.variableArgs = true;
exports.default = NotFound;
