import { Config } from 'cli-engine-config';
export declare type CachePlugin = {
    [k: string]: any;
    name: string;
    type: string;
};
export declare type CacheJSON = {
    version: string;
    plugins: {
        [k: string]: CachePlugin;
    };
};
export declare class PluginCache {
    protected config: Config;
    constructor(config: Config);
    needsSave: boolean;
    private cache;
    private mtime?;
    private saving?;
    save(): Promise<void>;
    private fetchPromises;
    fetch<T>(key: string, prop: string, fn: () => Promise<T>): Promise<T>;
    get(key: string, prop: string): Promise<any>;
    set(key: string, prop: string, v: any): Promise<any>;
    reset(key: string): Promise<void>;
    private _init;
    private init();
    private readonly file;
    private read();
    private canWrite();
    private getLastUpdated();
}
