"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deps_1 = require("../deps");
const plugin_1 = require("./plugin");
const manager_1 = require("./manager");
const path = require("path");
class CorePlugins extends manager_1.PluginManager {
    async _init() {
        this.plugins = this.submanagers = await Promise.all(this.config.corePlugins.map(name => this.initPlugin(name)));
    }
    async initPlugin(name) {
        const pjson = await deps_1.default.file.fetchJSONFile(path.join(this.root(name), 'package.json'));
        return new CorePlugin({
            name,
            type: 'core',
            config: this.config,
            cache: this.cache,
            manifest: this.manifest,
            root: this.root(name),
            version: pjson.version,
            pjson,
        });
    }
    root(name) {
        return path.join(this.config.root, 'node_modules', name);
    }
}
exports.CorePlugins = CorePlugins;
class CorePlugin extends plugin_1.Plugin {
    constructor(options) {
        super(options);
        this.type = 'core';
    }
}
exports.CorePlugin = CorePlugin;
