import { Config } from 'cli-engine-config';
import { ICommand } from 'cli-engine-config';
import { UserPlugins } from './user';
import { Builtin } from './builtin';
import { LinkPlugins } from './link';
import { CorePlugins } from './core';
import { Plugin } from './plugin';
import { PluginManager } from './manager';
export declare type InstallOptions = LinkInstallOptions | UserInstallOptions;
export interface UserInstallOptions {
    type: 'user';
    name: string;
    tag: string;
    force?: boolean;
}
export interface LinkInstallOptions {
    type: 'link';
    root: string;
    force?: boolean;
}
export declare class Plugins extends PluginManager {
    builtin: Builtin;
    core: CorePlugins;
    user: UserPlugins;
    link: LinkPlugins;
    protected debug: any;
    private lock;
    constructor({config}: {
        config: Config;
    });
    install(options: InstallOptions): Promise<void>;
    update(): Promise<void>;
    uninstall(name: string): Promise<void>;
    init(): Promise<void>;
    protected _init(): Promise<void>;
    findCommand(id: string, options: {
        must: true;
    }): Promise<ICommand>;
    findCommand(id: string, options?: {
        must?: boolean;
    }): Promise<ICommand | undefined>;
    readonly plugins: Plugin[];
    private save();
    private migrate();
    private getLinkedPackageName(root);
    private pluginType(name);
}
