import { Plugin, PluginOptions, PluginType } from './plugin';
import { PluginManager } from './manager';
export declare class LinkPlugins extends PluginManager {
    plugins: LinkPlugin[];
    install(root: string): Promise<void>;
    findByRoot(root: string): Promise<LinkPlugin | undefined>;
    protected _init(): Promise<void>;
    private loadPlugin(root, forceRefresh?);
}
export declare class LinkPlugin extends Plugin {
    type: PluginType;
    private forceRefresh;
    constructor(opts: {
        forceRefresh: boolean;
    } & PluginOptions);
    protected resetCache(): Promise<void>;
    protected _refresh(): Promise<void>;
    protected _needsRefresh(): Promise<boolean>;
    private refreshType();
    private updateNodeModulesNeeded();
    private prepareNeeded();
    private updateNodeModules();
    private prepare();
    private lastUpdated();
    private manifestInfo();
}
