import { Config } from 'cli-engine-config';
export interface ManifestLink {
    name: string;
    root: string;
    lastUpdated: Date;
}
export interface ManifestUser {
    name: string;
    tag: string;
}
export interface ManifestUserOpts {
    type: 'user';
    name: string;
    tag: string;
}
export interface ManifestLinkOpts {
    type: 'link';
    name: string;
    root: string;
}
export declare type ManifestJSON = {
    version: 1;
    node_version?: string;
    user: ManifestUser[];
    link: {
        name: string;
        root: string;
        lastUpdated: string;
    }[];
};
export declare class PluginManifest {
    constructor(config: Config);
    config: Config;
    nodeVersionChanged: boolean;
    needsSave: boolean;
    mtime?: number;
    private saving;
    save(): Promise<void>;
    list(type: 'user'): Promise<ManifestUser[]>;
    list(type: 'link'): Promise<ManifestLink[]>;
    add(opts: ManifestUserOpts | ManifestLinkOpts): Promise<void>;
    remove(name: string): Promise<void>;
    update(type: 'link', name: string): Promise<void>;
    private manifest;
    private _init;
    init(): Promise<void>;
    private readonly file;
    private read();
    private canWrite();
    getLastUpdated(): Promise<number | undefined>;
}
