export declare type Commands = {
    [k: string]: CommandInfo;
};
export declare type CommandInfo = {
    id: string;
    hidden: boolean;
    help: string;
    helpLine: [string, string | undefined];
};
export declare type TopicOpts = {
    name: string;
    description?: string;
    hidden?: boolean;
    commands?: Commands;
    subtopics?: Topics;
};
export declare type Topics = {
    [k: string]: Topic;
};
export declare class Topic {
    static parentTopicIDof(id: string): string;
    static findTopic(name: string, topics: Topics): Topic | undefined;
    static findOrCreateTopic(opts: TopicOpts, topics: Topics): Topic;
    static mergeSubtopics(...subtopics: (Topics | undefined)[]): Topics;
    static mergeTopics(a: TopicOpts, b: TopicOpts): Topic;
    name: string;
    description?: string;
    hidden: boolean;
    subtopics: Topics;
    commands: Commands;
    constructor(opts: TopicOpts);
}
