import { Plugin, PluginType, PluginOptions } from './plugin';
import { PluginManager } from './manager';
export declare class UserPlugins extends PluginManager {
    plugins: UserPlugin[];
    update(): Promise<void>;
    install(name: string, tag: string): Promise<void>;
    uninstall(name: string): Promise<void>;
    protected _needsRefresh(): Promise<boolean>;
    protected _refresh(): Promise<void>;
    protected _init(): Promise<void>;
    private loadPlugin(name, tag);
    private userPluginPath(name);
    private readonly userPluginsDir;
    private readonly pjsonPath;
    private yarn();
    private createPJSON();
}
export declare type UserPluginOptions = PluginOptions & {
    tag: string;
};
export declare class UserPlugin extends Plugin {
    type: PluginType;
    tag: string;
    constructor(opts: UserPluginOptions);
}
